<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfATSReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfATSReportItem extends AbstractStructArrayBase
{
    /**
     * The FailureItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\ATSReportItem[]
     */
    public $FailureItem;
    /**
     * Constructor method for ArrayOfATSReportItem
     * @uses ArrayOfATSReportItem::setFailureItem()
     * @param \CustomerManagement\StructType\ATSReportItem[] $failureItem
     */
    public function __construct(array $failureItem = array())
    {
        $this
            ->setFailureItem($failureItem);
    }
    /**
     * Get FailureItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\ATSReportItem[]|null
     */
    public function getFailureItem()
    {
        return isset($this->FailureItem) ? $this->FailureItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFailureItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFailureItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFailureItemForArrayConstraintsFromSetFailureItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfATSReportItemFailureItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfATSReportItemFailureItemItem instanceof \CustomerManagement\StructType\ATSReportItem) {
                $invalidValues[] = is_object($arrayOfATSReportItemFailureItemItem) ? get_class($arrayOfATSReportItemFailureItemItem) : sprintf('%s(%s)', gettype($arrayOfATSReportItemFailureItemItem), var_export($arrayOfATSReportItemFailureItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FailureItem property can only contain items of type \CustomerManagement\StructType\ATSReportItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FailureItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\ATSReportItem[] $failureItem
     * @return \CustomerManagement\ArrayType\ArrayOfATSReportItem
     */
    public function setFailureItem(array $failureItem = array())
    {
        // validation for constraint: array
        if ('' !== ($failureItemArrayErrorMessage = self::validateFailureItemForArrayConstraintsFromSetFailureItem($failureItem))) {
            throw new \InvalidArgumentException($failureItemArrayErrorMessage, __LINE__);
        }
        if (is_null($failureItem) || (is_array($failureItem) && empty($failureItem))) {
            unset($this->FailureItem);
        } else {
            $this->FailureItem = $failureItem;
        }
        return $this;
    }
    /**
     * Add item to FailureItem value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\ATSReportItem $item
     * @return \CustomerManagement\ArrayType\ArrayOfATSReportItem
     */
    public function addToFailureItem(\CustomerManagement\StructType\ATSReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\ATSReportItem) {
            throw new \InvalidArgumentException(sprintf('The FailureItem property can only contain items of type \CustomerManagement\StructType\ATSReportItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FailureItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\ATSReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\ATSReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\ATSReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\ATSReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\ATSReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FailureItem
     */
    public function getAttributeName()
    {
        return 'FailureItem';
    }
}
